Index: libmpc/trunk/win32/libcommon.vcproj
===================================================================
--- libmpc/trunk/win32/libcommon.vcproj	(revision 363)
+++ libmpc/trunk/win32/libcommon.vcproj	(revision 422)
@@ -2,9 +2,10 @@
 <VisualStudioProject
 	ProjectType="Visual C++"
-	Version="8.00"
+	Version="9.00"
 	Name="libcommon"
 	ProjectGUID="{49A26D14-0AD0-497E-A982-42BFD4D992FC}"
 	RootNamespace="libcommon"
 	Keyword="Win32Proj"
+	TargetFrameworkVersion="131072"
 	>
 	<Platforms>
@@ -40,4 +41,5 @@
 				Name="VCCLCompilerTool"
 				Optimization="0"
+				AdditionalIncludeDirectories="../include"
 				PreprocessorDefinitions="_WIN32;WIN32;_DEBUG;_LIB;_CRT_SECURE_NO_DEPRECATE"
 				ExceptionHandling="0"
@@ -46,5 +48,4 @@
 				BrowseInformation="1"
 				WarningLevel="3"
-				Detect64BitPortabilityProblems="true"
 				DebugInformationFormat="1"
 				CompileAs="1"
@@ -85,5 +86,5 @@
 			IntermediateDirectory="$(ConfigurationName)"
 			ConfigurationType="4"
-			CharacterSet="1"
+			CharacterSet="0"
 			WholeProgramOptimization="1"
 			>
@@ -105,4 +106,6 @@
 			<Tool
 				Name="VCCLCompilerTool"
+				Optimization="2"
+				AdditionalIncludeDirectories="../include"
 				PreprocessorDefinitions="_WIN32;WIN32;NDEBUG;_LIB;_CRT_SECURE_NO_DEPRECATE"
 				StringPooling="true"
@@ -164,4 +167,8 @@
 				>
 			</File>
+			<File
+				RelativePath="..\common\tags.c"
+				>
+			</File>
 		</Filter>
 		<Filter
Index: libmpc/trunk/win32/libmpcdec.vcproj
===================================================================
--- libmpc/trunk/win32/libmpcdec.vcproj	(revision 363)
+++ libmpc/trunk/win32/libmpcdec.vcproj	(revision 422)
@@ -2,8 +2,9 @@
 <VisualStudioProject
 	ProjectType="Visual C++"
-	Version="8.00"
+	Version="9.00"
 	Name="libmpcdec"
 	ProjectGUID="{4C5362CD-0BF2-4B3B-971B-8293EB1A1DC3}"
 	RootNamespace="libmpcdec"
+	TargetFrameworkVersion="131072"
 	>
 	<Platforms>
@@ -48,5 +49,4 @@
 				BrowseInformation="1"
 				WarningLevel="3"
-				Detect64BitPortabilityProblems="true"
 				DebugInformationFormat="1"
 				CompileAs="1"
@@ -87,5 +87,5 @@
 			IntermediateDirectory="$(ConfigurationName)"
 			ConfigurationType="4"
-			CharacterSet="1"
+			CharacterSet="0"
 			WholeProgramOptimization="1"
 			>
@@ -107,4 +107,5 @@
 			<Tool
 				Name="VCCLCompilerTool"
+				Optimization="2"
 				AdditionalIncludeDirectories="../include"
 				PreprocessorDefinitions="WIN32;NDEBUG;_CONSOLE;_CRT_SECURE_NO_DEPRECATE"
Index: libmpc/trunk/win32/libmpcenc.vcproj
===================================================================
--- libmpc/trunk/win32/libmpcenc.vcproj	(revision 363)
+++ libmpc/trunk/win32/libmpcenc.vcproj	(revision 422)
@@ -2,9 +2,10 @@
 <VisualStudioProject
 	ProjectType="Visual C++"
-	Version="8.00"
+	Version="9.00"
 	Name="libmpcenc"
 	ProjectGUID="{44EC1266-D2EE-47B8-ACFC-8BD52E7FFF96}"
 	RootNamespace="libmpcenc"
 	Keyword="Win32Proj"
+	TargetFrameworkVersion="131072"
 	>
 	<Platforms>
@@ -47,5 +48,4 @@
 				BrowseInformation="1"
 				WarningLevel="3"
-				Detect64BitPortabilityProblems="true"
 				DebugInformationFormat="1"
 				CompileAs="1"
@@ -86,4 +86,5 @@
 			IntermediateDirectory="$(ConfigurationName)"
 			ConfigurationType="4"
+			CharacterSet="0"
 			WholeProgramOptimization="1"
 			>
@@ -105,4 +106,5 @@
 			<Tool
 				Name="VCCLCompilerTool"
+				Optimization="2"
 				AdditionalIncludeDirectories="../include"
 				PreprocessorDefinitions="_WIN32;WIN32;NDEBUG;_LIB;_CRT_SECURE_NO_DEPRECATE;FAST_MATH"
Index: libmpc/trunk/win32/libmpcpsy.vcproj
===================================================================
--- libmpc/trunk/win32/libmpcpsy.vcproj	(revision 363)
+++ libmpc/trunk/win32/libmpcpsy.vcproj	(revision 422)
@@ -2,9 +2,10 @@
 <VisualStudioProject
 	ProjectType="Visual C++"
-	Version="8.00"
+	Version="9.00"
 	Name="libmpcpsy"
 	ProjectGUID="{7CF31624-B40E-466F-9107-785816C787C4}"
 	RootNamespace="libmpcpsy"
 	Keyword="Win32Proj"
+	TargetFrameworkVersion="131072"
 	>
 	<Platforms>
@@ -47,5 +48,4 @@
 				BrowseInformation="1"
 				WarningLevel="3"
-				Detect64BitPortabilityProblems="true"
 				DebugInformationFormat="1"
 				CompileAs="1"
@@ -86,4 +86,5 @@
 			IntermediateDirectory="$(ConfigurationName)"
 			ConfigurationType="4"
+			CharacterSet="0"
 			WholeProgramOptimization="1"
 			>
@@ -105,4 +106,5 @@
 			<Tool
 				Name="VCCLCompilerTool"
+				Optimization="2"
 				AdditionalIncludeDirectories="../include"
 				PreprocessorDefinitions="_WIN32;WIN32;NDEBUG;_LIB;_CRT_SECURE_NO_DEPRECATE;FAST_MATH;CVD_FASTLOG"
@@ -112,5 +114,4 @@
 				FloatingPointModel="2"
 				WarningLevel="3"
-				Detect64BitPortabilityProblems="true"
 				CompileAs="1"
 			/>
Index: libmpc/trunk/win32/libwavformat.vcproj
===================================================================
--- libmpc/trunk/win32/libwavformat.vcproj	(revision 363)
+++ libmpc/trunk/win32/libwavformat.vcproj	(revision 422)
@@ -2,9 +2,10 @@
 <VisualStudioProject
 	ProjectType="Visual C++"
-	Version="8,00"
+	Version="9.00"
 	Name="libwavformat"
 	ProjectGUID="{13D176A2-B6BB-403F-A816-AA1F388078B7}"
 	RootNamespace="libwavformat"
 	Keyword="Win32Proj"
+	TargetFrameworkVersion="131072"
 	>
 	<Platforms>
@@ -48,5 +49,4 @@
 				BrowseInformation="1"
 				WarningLevel="3"
-				Detect64BitPortabilityProblems="true"
 				DebugInformationFormat="1"
 				CompileAs="1"
@@ -87,5 +87,5 @@
 			IntermediateDirectory="$(ConfigurationName)"
 			ConfigurationType="4"
-			CharacterSet="1"
+			CharacterSet="0"
 			WholeProgramOptimization="1"
 			>
@@ -107,4 +107,5 @@
 			<Tool
 				Name="VCCLCompilerTool"
+				Optimization="2"
 				PreprocessorDefinitions="WIN32;NDEBUG;_LIB"
 				StringPooling="true"
@@ -112,6 +113,6 @@
 				BufferSecurityCheck="false"
 				EnableFunctionLevelLinking="true"
+				FloatingPointModel="2"
 				WarningLevel="3"
-				Detect64BitPortabilityProblems="true"
 				DebugInformationFormat="0"
 				CompileAs="1"
Index: libmpc/trunk/win32/mpc2sv8.vcproj
===================================================================
--- libmpc/trunk/win32/mpc2sv8.vcproj	(revision 363)
+++ libmpc/trunk/win32/mpc2sv8.vcproj	(revision 422)
@@ -2,9 +2,10 @@
 <VisualStudioProject
 	ProjectType="Visual C++"
-	Version="8.00"
+	Version="9.00"
 	Name="mpc2sv8"
 	ProjectGUID="{36225C6A-FFA3-4E70-928E-1F69F7A3FCE1}"
 	RootNamespace="mppenc"
 	Keyword="Win32Proj"
+	TargetFrameworkVersion="131072"
 	>
 	<Platforms>
@@ -41,5 +42,5 @@
 				Name="VCCLCompilerTool"
 				Optimization="0"
-				AdditionalIncludeDirectories="../include;../libmpcenc;../libmpcpsy"
+				AdditionalIncludeDirectories="../include;../libmpcenc;../libmpcpsy;."
 				PreprocessorDefinitions="_WIN32;WIN32;_DEBUG;_CONSOLE;_CRT_SECURE_NO_DEPRECATE"
 				ExceptionHandling="0"
@@ -48,5 +49,4 @@
 				BrowseInformation="1"
 				WarningLevel="3"
-				Detect64BitPortabilityProblems="true"
 				DebugInformationFormat="1"
 				CompileAs="1"
@@ -70,4 +70,6 @@
 				MapExports="true"
 				SubSystem="1"
+				RandomizedBaseAddress="1"
+				DataExecutionPrevention="0"
 				TargetMachine="1"
 			/>
@@ -90,7 +92,4 @@
 			<Tool
 				Name="VCAppVerifierTool"
-			/>
-			<Tool
-				Name="VCWebDeploymentTool"
 			/>
 			<Tool
@@ -124,5 +123,6 @@
 			<Tool
 				Name="VCCLCompilerTool"
-				AdditionalIncludeDirectories="../include;../libmpcenc;../libmpcpsy"
+				Optimization="2"
+				AdditionalIncludeDirectories="../include;../libmpcenc;../libmpcpsy;."
 				PreprocessorDefinitions="_WIN32;WIN32;NDEBUG;_CONSOLE;_CRT_SECURE_NO_DEPRECATE"
 				ExceptionHandling="0"
@@ -131,5 +131,4 @@
 				FloatingPointModel="2"
 				WarningLevel="3"
-				Detect64BitPortabilityProblems="true"
 				CompileAs="1"
 			/>
@@ -150,4 +149,6 @@
 				OptimizeReferences="2"
 				EnableCOMDATFolding="2"
+				RandomizedBaseAddress="1"
+				DataExecutionPrevention="0"
 				TargetMachine="1"
 				AllowIsolation="false"
@@ -171,7 +172,4 @@
 			<Tool
 				Name="VCAppVerifierTool"
-			/>
-			<Tool
-				Name="VCWebDeploymentTool"
 			/>
 			<Tool
Index: libmpc/trunk/win32/mpccut.vcproj
===================================================================
--- libmpc/trunk/win32/mpccut.vcproj	(revision 363)
+++ libmpc/trunk/win32/mpccut.vcproj	(revision 422)
@@ -2,9 +2,10 @@
 <VisualStudioProject
 	ProjectType="Visual C++"
-	Version="8.00"
+	Version="9.00"
 	Name="mpccut"
 	ProjectGUID="{ABBF9DD7-650F-48A8-9810-B76F233520F3}"
 	RootNamespace="mppenc"
 	Keyword="Win32Proj"
+	TargetFrameworkVersion="131072"
 	>
 	<Platforms>
@@ -48,5 +49,4 @@
 				BrowseInformation="1"
 				WarningLevel="3"
-				Detect64BitPortabilityProblems="true"
 				DebugInformationFormat="1"
 				CompileAs="1"
@@ -70,4 +70,6 @@
 				MapExports="true"
 				SubSystem="1"
+				RandomizedBaseAddress="1"
+				DataExecutionPrevention="0"
 				TargetMachine="1"
 			/>
@@ -90,7 +92,4 @@
 			<Tool
 				Name="VCAppVerifierTool"
-			/>
-			<Tool
-				Name="VCWebDeploymentTool"
 			/>
 			<Tool
@@ -124,4 +123,5 @@
 			<Tool
 				Name="VCCLCompilerTool"
+				Optimization="2"
 				AdditionalIncludeDirectories="../include;../libmpcenc;../libmpcpsy;../win32"
 				PreprocessorDefinitions="_WIN32;WIN32;NDEBUG;_CONSOLE;_CRT_SECURE_NO_DEPRECATE"
@@ -131,5 +131,4 @@
 				FloatingPointModel="2"
 				WarningLevel="3"
-				Detect64BitPortabilityProblems="true"
 				CompileAs="1"
 			/>
@@ -150,4 +149,6 @@
 				OptimizeReferences="2"
 				EnableCOMDATFolding="2"
+				RandomizedBaseAddress="1"
+				DataExecutionPrevention="0"
 				TargetMachine="1"
 				AllowIsolation="false"
@@ -171,7 +172,4 @@
 			<Tool
 				Name="VCAppVerifierTool"
-			/>
-			<Tool
-				Name="VCWebDeploymentTool"
 			/>
 			<Tool
Index: libmpc/trunk/win32/mpcdec.vcproj
===================================================================
--- libmpc/trunk/win32/mpcdec.vcproj	(revision 363)
+++ libmpc/trunk/win32/mpcdec.vcproj	(revision 422)
@@ -2,9 +2,10 @@
 <VisualStudioProject
 	ProjectType="Visual C++"
-	Version="8.00"
+	Version="9.00"
 	Name="mpcdec"
 	ProjectGUID="{A527175B-22A9-41AB-B2E8-580F573CCAFB}"
 	RootNamespace="mpcdec"
 	Keyword="Win32Proj"
+	TargetFrameworkVersion="131072"
 	>
 	<Platforms>
@@ -48,5 +49,4 @@
 				UsePrecompiledHeader="0"
 				WarningLevel="3"
-				Detect64BitPortabilityProblems="true"
 				DebugInformationFormat="1"
 				CompileAs="1"
@@ -68,4 +68,6 @@
 				GenerateDebugInformation="true"
 				SubSystem="1"
+				RandomizedBaseAddress="1"
+				DataExecutionPrevention="0"
 				TargetMachine="1"
 				AllowIsolation="false"
@@ -91,7 +93,4 @@
 			/>
 			<Tool
-				Name="VCWebDeploymentTool"
-			/>
-			<Tool
 				Name="VCPostBuildEventTool"
 				CommandLine="copy &quot;$(TargetPath)&quot; ..\bin"
@@ -103,5 +102,5 @@
 			IntermediateDirectory="$(ConfigurationName)"
 			ConfigurationType="1"
-			CharacterSet="1"
+			CharacterSet="0"
 			WholeProgramOptimization="1"
 			>
@@ -123,4 +122,5 @@
 			<Tool
 				Name="VCCLCompilerTool"
+				Optimization="2"
 				AdditionalIncludeDirectories="../include,../libwavformat,../win32"
 				PreprocessorDefinitions="WIN32;NDEBUG;_CONSOLE;_CRT_SECURE_NO_DEPRECATE"
@@ -131,5 +131,4 @@
 				FloatingPointModel="2"
 				WarningLevel="3"
-				Detect64BitPortabilityProblems="true"
 				DebugInformationFormat="0"
 				CompileAs="1"
@@ -151,4 +150,6 @@
 				OptimizeReferences="2"
 				EnableCOMDATFolding="2"
+				RandomizedBaseAddress="1"
+				DataExecutionPrevention="0"
 				TargetMachine="1"
 				AllowIsolation="false"
@@ -174,7 +175,4 @@
 			/>
 			<Tool
-				Name="VCWebDeploymentTool"
-			/>
-			<Tool
 				Name="VCPostBuildEventTool"
 				CommandLine="copy &quot;$(TargetPath)&quot; ..\bin"
Index: libmpc/trunk/win32/mpcenc.vcproj
===================================================================
--- libmpc/trunk/win32/mpcenc.vcproj	(revision 363)
+++ libmpc/trunk/win32/mpcenc.vcproj	(revision 422)
@@ -2,9 +2,10 @@
 <VisualStudioProject
 	ProjectType="Visual C++"
-	Version="8.00"
+	Version="9.00"
 	Name="mpcenc"
 	ProjectGUID="{15082E34-9324-469F-8423-F995B4814A37}"
 	RootNamespace="mppenc"
 	Keyword="Win32Proj"
+	TargetFrameworkVersion="131072"
 	>
 	<Platforms>
@@ -48,5 +49,4 @@
 				BrowseInformation="1"
 				WarningLevel="3"
-				Detect64BitPortabilityProblems="true"
 				DebugInformationFormat="1"
 				CompileAs="1"
@@ -70,4 +70,6 @@
 				MapExports="true"
 				SubSystem="1"
+				RandomizedBaseAddress="1"
+				DataExecutionPrevention="0"
 				TargetMachine="1"
 			/>
@@ -90,7 +92,4 @@
 			<Tool
 				Name="VCAppVerifierTool"
-			/>
-			<Tool
-				Name="VCWebDeploymentTool"
 			/>
 			<Tool
@@ -124,4 +123,5 @@
 			<Tool
 				Name="VCCLCompilerTool"
+				Optimization="2"
 				AdditionalIncludeDirectories="../include;../libmpcenc;../libmpcpsy"
 				PreprocessorDefinitions="_WIN32;WIN32;NDEBUG;_CONSOLE;_CRT_SECURE_NO_DEPRECATE;FAST_MATH"
@@ -131,5 +131,4 @@
 				FloatingPointModel="2"
 				WarningLevel="3"
-				Detect64BitPortabilityProblems="true"
 				CompileAs="1"
 			/>
@@ -150,4 +149,6 @@
 				OptimizeReferences="2"
 				EnableCOMDATFolding="2"
+				RandomizedBaseAddress="1"
+				DataExecutionPrevention="0"
 				TargetMachine="1"
 				AllowIsolation="false"
@@ -171,7 +172,4 @@
 			<Tool
 				Name="VCAppVerifierTool"
-			/>
-			<Tool
-				Name="VCWebDeploymentTool"
 			/>
 			<Tool
@@ -206,8 +204,4 @@
 			</File>
 			<File
-				RelativePath="..\mpcenc\tags.c"
-				>
-			</File>
-			<File
 				RelativePath="..\mpcenc\wave_in.c"
 				>
Index: libmpc/trunk/win32/mpcgain.vcproj
===================================================================
--- libmpc/trunk/win32/mpcgain.vcproj	(revision 363)
+++ libmpc/trunk/win32/mpcgain.vcproj	(revision 422)
@@ -2,9 +2,10 @@
 <VisualStudioProject
 	ProjectType="Visual C++"
-	Version="8.00"
+	Version="9.00"
 	Name="mpcgain"
 	ProjectGUID="{76CBB7D4-0524-4569-9150-34BDE4235D04}"
 	RootNamespace="mpcgain"
 	Keyword="Win32Proj"
+	TargetFrameworkVersion="131072"
 	>
 	<Platforms>
@@ -64,4 +65,6 @@
 				GenerateDebugInformation="true"
 				SubSystem="1"
+				RandomizedBaseAddress="1"
+				DataExecutionPrevention="0"
 				TargetMachine="1"
 			/>
@@ -85,7 +88,4 @@
 			/>
 			<Tool
-				Name="VCWebDeploymentTool"
-			/>
-			<Tool
 				Name="VCPostBuildEventTool"
 			/>
@@ -96,5 +96,5 @@
 			IntermediateDirectory="$(ConfigurationName)"
 			ConfigurationType="1"
-			CharacterSet="1"
+			CharacterSet="0"
 			WholeProgramOptimization="1"
 			>
@@ -116,7 +116,9 @@
 			<Tool
 				Name="VCCLCompilerTool"
+				Optimization="2"
 				AdditionalIncludeDirectories="../include;../../../libreplaygain/include"
 				PreprocessorDefinitions="WIN32;NDEBUG;_CONSOLE"
 				RuntimeLibrary="0"
+				BufferSecurityCheck="false"
 				FloatingPointModel="2"
 				UsePrecompiledHeader="0"
@@ -139,4 +141,6 @@
 				OptimizeReferences="2"
 				EnableCOMDATFolding="2"
+				RandomizedBaseAddress="1"
+				DataExecutionPrevention="0"
 				TargetMachine="1"
 			/>
@@ -158,7 +162,4 @@
 			<Tool
 				Name="VCAppVerifierTool"
-			/>
-			<Tool
-				Name="VCWebDeploymentTool"
 			/>
 			<Tool
Index: libmpc/trunk/win32/musepack.sln
===================================================================
--- libmpc/trunk/win32/musepack.sln	(revision 363)
+++ libmpc/trunk/win32/musepack.sln	(revision 422)
@@ -1,5 +1,5 @@
 ﻿
-Microsoft Visual Studio Solution File, Format Version 9.00
-# Visual Studio 2005
+Microsoft Visual Studio Solution File, Format Version 10.00
+# Visual Studio 2008
 Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "mpcenc", "mpcenc.vcproj", "{15082E34-9324-469F-8423-F995B4814A37}"
 	ProjectSection(ProjectDependencies) = postProject